unit U_uninstall;
{Unit ralis par Stphane PROTIN}
{Cette unit est associe  une Form : F_auto_desinstall}
{L'utilit de cette unit est de supprimer ce programme en cours d'utilisation}
{Dernires modifications : le 16 juin 2003}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Registry, ShellAPI;

type
  TF_auto_desinstall = class(TForm)
    B_autodesinstall: TButton;
    procedure B_autodesinstallClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_auto_desinstall: TF_auto_desinstall;

implementation

{$R *.dfm}

function GetTempDossier: String;
{-----------------------------------------------------------------------------------}
{renvoie le dossier "temporaire de Windows"                                         }
{ cette fonction renvoie le dossier temporaire en fonction des critres suivants:   }
{1.	le chemin spcifi par la variable d'environement TMP                       }
{2.	le chemin spcifi par la variable d'environement TEMP  si TMP non dfini   }
{3.	le dossier courant si aucune des deux variables TMP et TEMP ne sont dfinies}
{-----------------------------------------------------------------------------------}
var
  Dossier: array[0..MAX_PATH] of Char;
begin
  result:='';
  if GetTempPath(SizeOf(Dossier), Dossier)<>0 then Result := StrPas(Dossier);
end; //GetTempDossier



function create_file(name_fic_bat, name_fic_a_supprimer : string) : boolean ;
{-----------------------------------------------------------------------------------}
{  Cette fonction cre un petit fichier : name_fic_bat qui supprimera une fois le  }
{           fichier lanc : name_fic_a_supprimer et qui se dtruira aussi           }
{           Paramtres : le fichier suicidaire, le fichier  dsinstaller           }
{      Renvoie si la cration du fichier suicidaire s'est droule correctement     }
{-----------------------------------------------------------------------------------}
VAR
    fichier : TextFile ;
begin
  result := false ;
  AssignFile(fichier, name_fic_bat) ;     //assignation entre nom logique et nom
                                          //physique
  Rewrite(fichier) ;                      //ecriture du fichier
  writeln(fichier, '@echo off') ;         //on ne montre pas l'execution
  writeln(fichier, ':Suppression') ;      //debut de la boucle
  //le fichier que l'on essaiera de supprimer
  writeln(fichier, 'del "' + ExtractShortPathName(name_fic_a_supprimer) + '"') ;
  //s'il est encore l, on boucle
  writeln(fichier, 'if exist "' + ExtractShortPathName(name_fic_a_supprimer) +
  '" goto Suppression') ;
  //sinon, on supprime name_fic_bat
  writeln(fichier, 'del "' + ExtractShortPathName(name_fic_bat) + '"') ;
  closeFile(fichier) ;                    //on oublie pas de fermer le fichier aprs
                                          //cration
  result := true ;
end ; //create_file



procedure TF_auto_desinstall.B_autodesinstallClick(Sender: TObject);
VAR
    name_fic_bat, name_fic_a_supprimer : string ;
begin
  {Dfinitions des fichiers : respectivement : le dsinstalleur automatique, puis}
  {le programme  supprimer}
  name_fic_bat := GetTempDossier + 'AutoUninstall.bat' ;
  name_fic_a_supprimer := Application.EXEName ;

  {On lance la procedure}
  if create_file(name_fic_bat, name_fic_a_supprimer)

       {On lance le programme suicidaire}
       then begin
              ShellExecute(handle, 'open', PChar(name_fic_bat), nil, nil, SW_HIDE) ;
              Application.Terminate ;
            end

       {Si une erreure s'est produite dans la cration du fichier suicidaire, on prvient}
       else showmessage ('Une erreure s''est produite.') ;
end ; //TF_auto_desinstall.B_autodesinstallClick

end.
